import { MuSchema } from './schema';
import { MuWriteStream, MuReadStream } from 'mustreams';
export declare type MuNumberType = 'float32' | 'float64' | 'int8' | 'int16' | 'int32' | 'uint8' | 'uint16' | 'uint32';
export declare abstract class MuNumber implements MuSchema<number> {
    readonly identity: number;
    readonly muType: MuNumberType;
    readonly json: object;
    constructor(value: number, type: MuNumberType);
    alloc(): number;
    free(_: number): void;
    equal(x: number, y: number): boolean;
    clone(x: number): number;
    copy(source: number, target: number): void;
    abstract diff(b: number, t: number, stream: MuWriteStream): boolean;
    abstract patch(b: number, stream: MuReadStream): number;
}
