"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var gendata_1 = require("./gendata");
console.log('---------- array ----------');
console.log('100Kx targets with 10 elements');
var u32Schema = new __1.MuArray(new __1.MuUint32());
var ten1 = gendata_1.genArray('uint32', 10);
var ten2 = gendata_1.genArray('uint32', 10);
var half = gendata_1.genArray('uint32', 5);
var doubled = gendata_1.genArray('uint32', 20);
var outs = gendata_1.createWriteStreams(1e5);
console.time('diff same length');
for (var i = 0; i < 1e5;) {
    u32Schema.diff(ten1, ten2, outs[i++]);
    u32Schema.diff(ten2, ten1, outs[i++]);
}
console.timeEnd('diff same length');
var meanContentBytes = gendata_1.calcContentBytes(outs);
outs = gendata_1.createWriteStreams(1e5);
console.time('diff shorter against longer');
for (var i = 0; i < 1e5; ++i) {
    u32Schema.diff(half, ten1, outs[i]);
}
console.timeEnd('diff shorter against longer');
outs = gendata_1.createWriteStreams(1e5);
console.time('diff longer against shorter');
for (var i = 0; i < 1e5; ++i) {
    u32Schema.diff(doubled, ten1, outs[i]);
}
console.timeEnd('diff longer against shorter');
console.log("using " + meanContentBytes + " bytes");
console.log('1Kx targets with 1K elements');
var k1 = gendata_1.genArray('uint32', 1e3);
var k2 = gendata_1.genArray('uint32', 1e3);
half = gendata_1.genArray('uint32', 500);
doubled = gendata_1.genArray('uint32', 2e3);
outs = gendata_1.createWriteStreams(1e3);
console.time('diff same length');
for (var i = 0; i < 1e3;) {
    u32Schema.diff(k1, k2, outs[i++]);
    u32Schema.diff(k2, k1, outs[i++]);
}
console.timeEnd('diff same length');
meanContentBytes = gendata_1.calcContentBytes(outs);
var inps = gendata_1.createReadStreams(outs);
console.time('patch same length');
for (var i = 0; i < 1e3;) {
    u32Schema.patch(k1, inps[i++]);
    u32Schema.patch(k2, inps[i++]);
}
console.timeEnd('patch same length');
outs = gendata_1.createWriteStreams(1e3);
console.time('diff shorter against longer');
for (var i = 0; i < 1e3; ++i) {
    u32Schema.diff(half, k1, outs[i]);
}
console.timeEnd('diff shorter against longer');
inps = gendata_1.createReadStreams(outs);
console.time('patch shorter to longer');
for (var i = 0; i < 1e3; ++i) {
    u32Schema.patch(half, inps[i++]);
}
console.timeEnd('patch shorter to longer');
outs = gendata_1.createWriteStreams(1e3);
console.time('diff longer against shorter');
for (var i = 0; i < 1e3; ++i) {
    u32Schema.diff(doubled, k1, outs[i]);
}
console.timeEnd('diff longer against shorter');
inps = gendata_1.createReadStreams(outs);
console.time('patch longer to shorter');
for (var i = 0; i < 1e3; ++i) {
    u32Schema.patch(doubled, inps[i]);
}
console.timeEnd('patch longer to shorter');
console.log("using " + meanContentBytes + " bytes");
console.log('10x targets with 100K elements');
var tenK1 = gendata_1.genArray('uint32', 1e5);
var tenK2 = gendata_1.genArray('uint32', 1e5);
half = gendata_1.genArray('uint32', 5e4);
doubled = gendata_1.genArray('uint32', 2e5);
outs = gendata_1.createWriteStreams(10);
console.time('diff same length');
for (var i = 0; i < 10;) {
    u32Schema.diff(tenK1, tenK2, outs[i++]);
    u32Schema.diff(tenK2, tenK1, outs[i++]);
}
console.timeEnd('diff same length');
meanContentBytes = gendata_1.calcContentBytes(outs);
outs = gendata_1.createWriteStreams(10);
console.time('diff shorter against longer');
for (var i = 0; i < 10; ++i) {
    u32Schema.diff(half, tenK1, outs[i]);
}
console.timeEnd('diff shorter against longer');
outs = gendata_1.createWriteStreams(10);
console.time('diff longer against shorter');
for (var i = 0; i < 10; ++i) {
    u32Schema.diff(doubled, tenK1, outs[i]);
}
console.timeEnd('diff longer against shorter');
console.log("using " + meanContentBytes + " bytes");
//# sourceMappingURL=array.js.map