"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var gendata_1 = require("./gendata");
console.log('---------- dictionary ----------');
console.log('1Kx targets with 1K props');
var schema = new __1.MuDictionary(new __1.MuUint32());
var emptyDict = {};
var dict1 = gendata_1.genDictionary('uint32', 1e3);
var dict2 = gendata_1.changeValues(dict1, 'uint32');
var outs = gendata_1.createWriteStreams(1e3);
console.time('diff more props');
for (var i = 0; i < 1e3; ++i) {
    schema.diff(emptyDict, dict1, outs[i]);
}
console.timeEnd('diff more props');
var inps = gendata_1.createReadStreams(outs);
console.time('patch more props');
for (var i = 0; i < 1e3; ++i) {
    schema.patch(emptyDict, inps[i]);
}
console.timeEnd('patch more props');
outs = gendata_1.createWriteStreams(1e3);
console.time('diff same set of props');
for (var i = 0; i < 1e3;) {
    schema.diff(dict1, dict2, outs[i++]);
    schema.diff(dict2, dict1, outs[i++]);
}
console.timeEnd('diff same set of props');
var meanContentBytes = gendata_1.calcContentBytes(outs);
inps = gendata_1.createReadStreams(outs);
console.time('patch same set of props');
for (var i = 0; i < 1e3;) {
    schema.patch(dict1, inps[i++]);
    schema.patch(dict2, inps[i++]);
}
console.timeEnd('patch same set of props');
var dict3 = gendata_1.genDictionary('uint32', 1e3);
outs = gendata_1.createWriteStreams(1e3);
console.time('diff all props replaced');
for (var i = 0; i < 1e3;) {
    schema.diff(dict1, dict3, outs[i++]);
    schema.diff(dict3, dict1, outs[i++]);
}
console.timeEnd('diff all props replaced');
inps = gendata_1.createReadStreams(outs);
console.time('patch all props replaced');
for (var i = 0; i < 1e3;) {
    schema.patch(dict1, inps[i++]);
    schema.patch(dict2, inps[i++]);
}
console.timeEnd('patch all props replaced');
var dict4 = gendata_1.shallowMerge(dict1, dict3);
outs = gendata_1.createWriteStreams(1e3);
console.time('diff half of all props removed');
for (var i = 0; i < 1e3; ++i) {
    schema.diff(dict4, dict2, outs[i]);
}
console.timeEnd('diff half of all props removed');
inps = gendata_1.createReadStreams(outs);
console.time('patch half of all props removed');
for (var i = 0; i < 1e3; ++i) {
    schema.patch(dict4, inps[i]);
}
console.timeEnd('patch half of all props removed');
console.log("using " + meanContentBytes + " bytes");
//# sourceMappingURL=dictionary.js.map