import { MuWriteStream, MuReadStream } from 'mustreams';
export declare function createWriteStreams(numStreams: number): MuWriteStream[];
export declare function createReadStreams(outStreams: MuWriteStream[]): MuReadStream[];
export declare function genArray(muType: string, length: number): any[];
export declare function genDictionary(muType: string, numProps: number): {};
export declare function changeValues<T extends object>(dict: T, muType: string): T;
export declare function shallowMerge<T extends object>(target: T, source: T): T;
export declare function genStruct(spec: any): any;
export declare const muType2ArrayType: {
    float32: Float32ArrayConstructor;
    float64: Float64ArrayConstructor;
    int8: Int8ArrayConstructor;
    int16: Int16ArrayConstructor;
    int32: Int32ArrayConstructor;
    uint8: Uint8ArrayConstructor;
    uint16: Uint16ArrayConstructor;
    uint32: Uint32ArrayConstructor;
};
export declare function genVector(muType: keyof typeof muType2ArrayType, dimension: number): Int8Array;
export declare function calcContentBytes(outs: MuWriteStream[]): number;
