"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var gendata_1 = require("./gendata");
console.log('---------- struct ----------');
var spec1 = {
    a: new __1.MuUint32(),
    b: new __1.MuUint32(),
    c: new __1.MuUint32(),
    d: new __1.MuUint32(),
    e: new __1.MuUint32(),
    f: new __1.MuUint32(),
    g: new __1.MuUint32(),
    h: new __1.MuUint32(),
};
var schema1 = new __1.MuStruct(spec1);
var struct1 = gendata_1.genStruct(spec1);
var struct2 = gendata_1.genStruct(spec1);
var outs = gendata_1.createWriteStreams(1e5);
console.time('diff structs of uint32');
for (var i = 0; i < 1e5;) {
    schema1.diff(struct1, struct2, outs[i++]);
    schema1.diff(struct2, struct1, outs[i++]);
}
console.timeEnd('diff structs of uint32');
var meanContentBytes = gendata_1.calcContentBytes(outs);
var inps = gendata_1.createReadStreams(outs);
console.time('patch structs of uint32');
for (var i = 0; i < 1e5;) {
    schema1.patch(struct1, inps[i++]);
    schema1.patch(struct2, inps[i++]);
}
console.timeEnd('patch structs of uint32');
console.log("using " + meanContentBytes + " bytes");
var spec2 = {
    a: new __1.MuFloat32(),
    b: new __1.MuFloat64(),
    c: new __1.MuInt8(),
    d: new __1.MuInt16(),
    e: new __1.MuInt32(),
    f: new __1.MuUint8(),
    g: new __1.MuUint16(),
    h: new __1.MuUint32(),
};
var schema2 = new __1.MuStruct(spec2);
var struct3 = gendata_1.genStruct(spec2);
var struct4 = gendata_1.genStruct(spec2);
outs = gendata_1.createWriteStreams(1e5);
console.time('diff structs with props of various types');
for (var i = 0; i < 1e5;) {
    schema2.diff(struct3, struct4, outs[i++]);
    schema2.diff(struct4, struct3, outs[i++]);
}
console.timeEnd('diff structs with props of various types');
meanContentBytes = gendata_1.calcContentBytes(outs);
inps = gendata_1.createReadStreams(outs);
console.time('patch structs with props of various types');
for (var i = 0; i < 1e5;) {
    schema2.patch(struct3, inps[i++]);
    schema2.patch(struct4, inps[i++]);
}
console.timeEnd('patch structs with props of various types');
console.log("using " + meanContentBytes + " bytes");
//# sourceMappingURL=struct.js.map