"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var gendata_1 = require("./gendata");
console.log('---------- vector ----------');
console.log('100Kx targets with 10 elements');
var schema1 = new __1.MuVector(new __1.MuUint32(), 10);
var ten1 = gendata_1.genVector('uint32', 10);
var ten2 = gendata_1.genVector('uint32', 10);
var outs = gendata_1.createWriteStreams(1e5);
console.time('diff vectors of uint32');
for (var i = 0; i < 1e5;) {
    schema1.diff(ten1, ten2, outs[i++]);
    schema1.diff(ten2, ten1, outs[i++]);
}
console.timeEnd('diff vectors of uint32');
var meanContentBytes = gendata_1.calcContentBytes(outs);
var inps = gendata_1.createReadStreams(outs);
console.time('patch vectors of uint32');
for (var i = 0; i < 1e5;) {
    schema1.patch(ten1, inps[i++]);
    schema1.patch(ten2, inps[i++]);
}
console.timeEnd('patch vectors of uint32');
console.log("using " + meanContentBytes + " bytes");
console.log('1Kx targets with 1K elements');
var schema2 = new __1.MuVector(new __1.MuUint32(), 1e3);
var k1 = gendata_1.genVector('uint32', 1e3);
var k2 = gendata_1.genVector('uint32', 1e3);
outs = gendata_1.createWriteStreams(1e3);
console.time('diff vectors of uint32');
for (var i = 0; i < 1e3;) {
    schema2.diff(k1, k2, outs[i++]);
    schema2.diff(k2, k1, outs[i++]);
}
console.timeEnd('diff vectors of uint32');
meanContentBytes = gendata_1.calcContentBytes(outs);
inps = gendata_1.createReadStreams(outs);
console.time('patch vectors of uint32');
for (var i = 0; i < 1e3;) {
    schema2.patch(k1, inps[i++]);
    schema2.patch(k2, inps[i++]);
}
console.timeEnd('patch vectors of uint32');
console.log("using " + meanContentBytes + " bytes");
console.log('10x targets with 100K elements');
var schema3 = new __1.MuVector(new __1.MuUint32(), 1e5);
var tenK1 = gendata_1.genVector('uint32', 1e5);
var tenK2 = gendata_1.genVector('uint32', 1e5);
outs = gendata_1.createWriteStreams(10);
console.time('diff vectors of uint32');
for (var i = 0; i < 10;) {
    schema3.diff(tenK1, tenK2, outs[i++]);
    schema3.diff(tenK2, tenK1, outs[i++]);
}
console.timeEnd('diff vectors of uint32');
meanContentBytes = gendata_1.calcContentBytes(outs);
inps = gendata_1.createReadStreams(outs);
console.time('patch vectors of uint32');
for (var i = 0; i < 10;) {
    schema3.patch(tenK1, inps[i++]);
    schema3.patch(tenK2, inps[i++]);
}
console.timeEnd('patch vectors of uint32');
console.log("using " + meanContentBytes + " bytes");
//# sourceMappingURL=vector.js.map