import { MuWriteStream, MuReadStream } from 'mustreams';
import { MuSchema } from './schema';
export declare type Dictionary<V extends MuSchema<any>> = {
    [key: string]: V['identity'];
};
export declare class MuDictionary<ValueSchema extends MuSchema<any>> implements MuSchema<Dictionary<ValueSchema>> {
    readonly identity: Dictionary<ValueSchema>;
    readonly muType: string;
    readonly muData: ValueSchema;
    readonly json: object;
    constructor(valueSchema: ValueSchema, id?: Dictionary<ValueSchema>);
    alloc(): Dictionary<ValueSchema>;
    free(x: Dictionary<ValueSchema>): void;
    equal(x: Dictionary<ValueSchema>, y: Dictionary<ValueSchema>): boolean;
    clone(x: Dictionary<ValueSchema>): Dictionary<ValueSchema>;
    copy(source: Dictionary<ValueSchema>, target: Dictionary<ValueSchema>): void;
    diff(base: Dictionary<ValueSchema>, target: Dictionary<ValueSchema>, stream: MuWriteStream): boolean;
    patch(base: Dictionary<ValueSchema>, stream: MuReadStream): Dictionary<ValueSchema>;
}
