import { MuSchema } from './schema';
import { MuWriteStream, MuReadStream } from 'mustreams';
export declare type Struct<Spec extends {
    [propName: string]: MuSchema<any>;
}> = {
    [P in keyof Spec]: Spec[P]['identity'];
};
export declare class MuStruct<Spec extends {
    [propName: string]: MuSchema<any>;
}> implements MuSchema<Struct<Spec>> {
    readonly muType: string;
    readonly muData: Spec;
    readonly identity: Struct<Spec>;
    readonly json: object;
    readonly alloc: () => Struct<Spec>;
    readonly free: (value: Struct<Spec>) => void;
    readonly equal: (x: Struct<Spec>, y: Struct<Spec>) => boolean;
    readonly clone: (value: Struct<Spec>) => Struct<Spec>;
    readonly copy: (source: Struct<Spec>, target: Struct<Spec>) => void;
    readonly diff: (base: Struct<Spec>, target: Struct<Spec>, stream: MuWriteStream) => boolean;
    readonly patch: (base: Struct<Spec>, stream: MuReadStream) => Struct<Spec>;
    constructor(spec: Spec);
}
