"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var test = require("tape");
var boolean_1 = require("../boolean");
var mustreams_1 = require("mustreams");
test('boolean', function (t) {
    var defaultValue = false;
    var b = new boolean_1.MuBoolean();
    t.equals(b.identity, defaultValue);
    t.equals(b.muType, 'boolean');
    t.equals(b.alloc(), defaultValue);
    t.equals(b.clone(false), false);
    b = new boolean_1.MuBoolean(true);
    t.equals(b.identity, true);
    t.equals(b.muType, 'boolean');
    t.equals(b.alloc(), true);
    t.equals(b.clone(true), true);
    var ws = new mustreams_1.MuWriteStream(4);
    t.equals(b.diff(true, true, ws), false);
    t.equals(b.diff(false, false, ws), false);
    t.equals(b.diff(true, false, ws), true);
    t.equals(b.diff(false, true, ws), true);
    var rs = new mustreams_1.MuReadStream(ws.buffer.uint8);
    t.equals(b.patch(true, rs), false);
    t.equals(b.patch(true, rs), true);
    t.end();
});
//# sourceMappingURL=boolean.js.map