"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var test = require("tape");
var __1 = require("../");
var helper_1 = require("./helper");
test('fixed-length ascii - diff() & patch()', function (t) {
    function ASCIIOfLeng(length) {
        var codePoints = new Array(length);
        for (var i = 0; i < length; ++i) {
            codePoints[i] = Math.random() * 0x80 | 0;
        }
        return String.fromCharCode.apply(String, codePoints);
    }
    var schema = new __1.MuFixedASCII(0);
    var testPair = helper_1.testPatchingPairFactory(t, schema);
    testPair('', '');
    schema = new __1.MuFixedASCII(1);
    testPair = helper_1.testPatchingPairFactory(t, schema);
    for (var i = 0; i < 100; ++i) {
        testPair(ASCIIOfLeng(1), ASCIIOfLeng(1));
        testPair(helper_1.simpleStrOfLeng(1), helper_1.simpleStrOfLeng(1));
    }
    schema = new __1.MuFixedASCII(0x10000);
    testPair = helper_1.testPatchingPairFactory(t, schema);
    for (var i = 0; i < 10; ++i) {
        testPair(ASCIIOfLeng(0x10000), ASCIIOfLeng(0x10000));
    }
    t.end();
});
//# sourceMappingURL=fixed-ascii.js.map